Index: trunk/kernel/mm/vmm.h
===================================================================
--- trunk/kernel/mm/vmm.h	(revision 690)
+++ trunk/kernel/mm/vmm.h	(revision 1)
@@ -289,172 +179,198 @@
 
 /*********************************************************************************************
- * This function allocates memory for a vseg descriptor, initialises it, and register it
- * in the VSL of the local process descriptor.
- * - For the FILE, ANON, & REMOTE types, it does not use the <base> argument, but uses 
- *   the specific VMM MMAP allocator.
- * - For the STACK type, it does not use the <base> and <size> arguments,  but uses the
- *   the specific VMM STACK allocator.
- * It checks collision with pre-existing vsegs.
- * To comply with the "on-demand" paging policy, this function does NOT modify the GPT,
- * and does not allocate physical memory for vseg data.
- * It should be called by a local thread (could be a RPC thread if the client thread is not
- * running in the reference cluster).
- *********************************************************************************************
- * @ process     : pointer on local processor descriptor.
- * @ type        : vseg type.
- * @ base        : vseg base address (or user thread ltid for an user stack vseg).
- * @ size        : vseg size (bytes).
- * @ file_offset : offset in file for CODE, DATA, FILE types. 
- * @ file_size   : can be smaller than "size" for DATA type.
- * @ mapper_xp   : extended pointer on mapper for CODE, DATA, FILE types.
- * @ cxy         : physical mapping cluster (for non distributed vsegs).
- * @ returns pointer on vseg if success / returns NULL if no memory, or conflict.
+ * This function allocates memory for a vseg descriptor, initialises it, and register it 
+ * in the VMM of the process. It checks the collision with pre-existing vsegs in VMM.
+ * For STACK and MMAP types vseg, it does not use the base argument, but uses the VMM STACK
+ * and MMAP specific allocators to get a base address in virtual space.
+ * To comply with the "on-demand" paging policy, this function does NOT mofify the
+ * page table, and does not allocate physical memory for vseg data.
+ *********************************************************************************************
+ * @ vmm   : pointer on process descriptor.
+ * @ base      : vseg base address
+ * @ size      : vseg size (bytes)
+ * @ type      : vseg type
+ * @ returns pointer on vseg if success / returns NULL if no memory or conflict.
  ********************************************************************************************/
 vseg_t * vmm_create_vseg( struct process_s * process,
-                          vseg_type_t        type,
-                          intptr_t           base,
-	                      uint32_t           size,
-                          uint32_t           file_offset,
-                          uint32_t           file_size,
-                          xptr_t             mapper_xp,
-                          cxy_t              cxy );
-
-/*********************************************************************************************
- * This function removes from the VMM of a local process descriptor, identified by
- * the <process> argument, the vseg identified by the <vseg> argument.  
- * It is called by the vmm_user_reset(), vmm_global_delete_vseg(), vmm_destroy() functions.
- * It must be called by a local thread, running in the cluster containing the modified VMM.
- * Use the RPC_VMM_REMOVE_VSEG if required.
- * It makes a kernel panic if the process is not registered in the local cluster.
- * For all vseg types, the vseg is detached from local VSL, and all associated PTEs are
- * unmapped from local GPT. Other actions depend on the vseg type:
- * Regarding the vseg descriptor release:
- *   . for ANON and REMOTE, the vseg is not released, but registered in local zombi_list.
- *   . for STACK the vseg is released to the local stack allocator.
- *   . for all other types, the vseg descriptor is released to the local kmem.
- * Regarding the physical pages release:
- *   . for KERNEL and FILE, the pages are not released to kmem.
- *   . for CODE and STACK, the pages are released to local kmem.
- *   . for DATA, ANON and REMOTE, the pages are released to relevant kmem only when
- *     the local cluster is the reference cluster.
- * The VSL lock protecting the VSL must be taken by the caller.
- *********************************************************************************************
- * @ process  : local pointer on process descriptor.
- * @ vseg     : local pointer on target vseg. 
- ********************************************************************************************/
-void vmm_remove_vseg( struct process_s * process,
-                      struct vseg_s    * vseg );
-
-/*********************************************************************************************
- * This function resize a local vseg identified by the <process> and <vseg> arguments.
- * Both the "size" and "base" fields are modified in the process VSL. When the new vseg
- * contains less pages than the target vseg, the relevant pages are removed from the GPT. 
- * It is called by the vmm_global_resize() and dev_fbf_resize_window() functions.
- * It must be called by a local thread, running in the cluster containing the modified VSL.
- * Use the RPC_VMM_RESIZE_VSEG if required.
- * The VSL lock protecting the VSL must be taken by the caller.
- *********************************************************************************************
- * @ process   : local pointer on process descriptor
- * @ vseg      : local pointer on target vseg
- * @ new_base  : vseg base address
- * @ new_size  : vseg size (bytes)
- ********************************************************************************************/
-void vmm_resize_vseg( struct process_s * process,
-                      struct vseg_s    * vseg,
-                      intptr_t           new_base,
-                      intptr_t           new_size );
-
-/*********************************************************************************************
- * This function checks that a given virtual address <vaddr> in a given <process> is
- * contained in a registered vseg. It can be called by any thread running in any cluster.
- * - if the vseg is registered in the local process VSL, it returns the local vseg pointer.
- * - if the vseg is missing in local VSL, it access directly the reference VSL.
- * - if the vseg is found in reference VSL, it updates the local VSL and returns this pointer.
- * It returns an error when the vseg is missing in the reference VMM, or when there is 
- * not enough memory for a new vseg descriptor in the calling thread cluster.
- * For both the local and the reference VSL, it takes the VSL lock before scanning the VSL.
+                          intptr_t           base, 
+	                      intptr_t           size, 
+	                      uint32_t           type );
+
+/*********************************************************************************************
+ * Ths function removes a vseg identified by it's pointer from the VMM of the calling process.
+ * - If the vseg has not the STACK or MMAP type, it is removed from the vsegs list,
+ *   and the physical memory allocated to vseg descriptor is released to KMEM.
+ * - If the vseg has the STACK type, it is removed from the vsegs list, the physical memory
+ *   allocated to vseg descriptor is released to KMEM, and the stack slot is returned to the
+ *   VMM STACK allocator.
+ * - If the vseg has the MMAP type, it is removed from the vsegs list and is registered
+ *   in the zombi_list of the VMM MMAP allocator for future reuse. The physical memory
+ *   allocated to vseg descriptor is NOT released to KMEM.
+ *********************************************************************************************
+ * @ vseg      : pointer on vseg to be removed.
+ ********************************************************************************************/
+void vmm_remove_vseg( vseg_t * vseg );
+
+/*********************************************************************************************
+ * This function allocates physical memory from the local cluster to map all PTEs 
+ * of a "kernel" vseg (type KCODE , KDATA, or KDEV) in the page table of process_zero.
+ * It should not be used for other vseg types, because "user" vsegs use the 
+ * "on-demand-paging" policy.
+ *********************************************************************************************
+ * @ vseg     : pointer on the vseg to be mapped.
+ * @ attr     : GPT attributes to be set for all vseg pages.
+ * @ returns 0 if success / returns ENOMEM if no memory
+ ********************************************************************************************/
+error_t vmm_map_vseg( vseg_t           * vseg,
+                      uint32_t           attr );
+
+/*********************************************************************************************
+ * This function unmap all PTEs of a given vseg, in the generic page table asociated 
+ * to a given process descriptor, and releases the corresponding physical memory.
+ * It can be used for any type of vseg.
+ *********************************************************************************************
+ * @ process  : pointer on process descriptor.
+ * @ vseg     : pointer on the vseg to be unmapped.
+ ********************************************************************************************/
+void vmm_unmap_vseg( struct process_s * process,
+                     vseg_t           * vseg );
+
+/*********************************************************************************************
+ * This function remove a given region (defined by a base address and a size) from
+ * the VMM of a given process descriptor. This can modify several vsegs:
+ * (a) if the region is not entirely mapped in an existing vseg, it's an error.
+ * (b) if the region has same base and size as an existing vseg, the vseg is removed.
+ * (c) if the removed region cut the vseg in two parts, it is removed and re-created.
+ * (d) if the removed region cut the vseg in three parts, it is removed, and two are created.
+ * TODO : cases (c) and (d) are not implemented [AG]
+ *********************************************************************************************
+ * @ process   : pointer on process descriptor
+ * @ base      : vseg base address
+ * @ size      : vseg size (bytes)
+ ********************************************************************************************/
+error_t vmm_resize_vseg( struct process_s * process,
+                         intptr_t           base,
+                         intptr_t           size );
+
+/*********************************************************************************************
+ * This function search if a given virtual address is contained in a vseg registered in
+ * the local process VMM and returns the vseg pointer if success.
+ *********************************************************************************************
+ * @ process   : pointer on process descriptor
+ * @ vaddr     : virtual address
+ * @ returns the pointer on vseg if success / returns NULL if failure.
+ *********************************************************************************************/
+vseg_t * vmm_get_vseg( struct process_s * process,
+                       intptr_t           vaddr );
+
+/*********************************************************************************************
+ * This function is called by the architecture specific exception handler when a 
+ * page fault has been detected in a given cluster. 
+ * If the local cluster is not the reference cluster, it send a RPC_VMM_GET_PTE
+ * to the reference cluster to get the missing PTE attributes and PPN, and update
+ * the local page table. If the local cluster is the reference, it call directly
+ * the vmm_get_pte() function.
+ *********************************************************************************************
+ * @ process   : pointer on process descriptor.
+ * @ vseg      : pointer on involved vseg.
+ * @ vpn       : VPN of the missing PTE.
+ * @ returns 0 if success / returns ENOMEM if no memory.
+ ********************************************************************************************/
+error_t vmm_handle_page_fault( struct process_s * process,
+                               vseg_t           * vseg,
+                               vpn_t              vpn ); 
+
+/*********************************************************************************************
+ * This function returns in the "attr" and "ppn" arguments the PTE associated to a given
+ * VPN for a given process. This function must be called on the reference cluster. 
+ * To get the PTE from another cluster, use the RPC_VMM_GET_PTE.
+ * The vseg containing the searched VPN should be registered in the reference VMM.
+ * If the PTE in the reference page table is unmapped, this function allocates the missing
+ * physical page from the target cluster defined by the vseg type, and update the reference
+ * page table. It can call a RPC_PMEM_GET_PAGES to get the missing physical page, 
+ * if the target cluster is not the reference cluster.
  *********************************************************************************************
  * @ process   : [in] pointer on process descriptor.
- * @ vaddr     : [in] virtual address.
- * @ vseg      : [out] local pointer on local vseg.
- * @ returns 0 if success / returns -1 if user error 
- ********************************************************************************************/
-error_t vmm_get_vseg( struct process_s  * process,
-                      intptr_t            vaddr,
-                      vseg_t           ** vseg );            
-
-/*********************************************************************************************
- * This function is called by the generic exception handler in case of page-fault event,
- * detected for a given <vpn>. The <process> argument is used to access the relevant VMM.
- * It checks the missing VPN and returns an user error if it is not in a registered vseg.
- * For a legal VPN, there is actually 3 cases:
- * 1) if the missing VPN belongs to a private vseg (STACK or CODE segment types, non
- *    replicated in all clusters), it allocates a new physical page, computes the attributes,
- *    depending on vseg type, and updates directly the local GPT.
- * 2) if the missing VPN belongs to a public vseg, it can be a false page-fault, when the VPN
- *    is mapped in the reference GPT, but not in the local GPT. For this false page-fault,
- *    the local GPT is simply updated from the reference GPT.
- * 3) if the missing VPN is public, and unmapped in the ref GPT, it is a true page fault.
- *    The calling thread  allocates a new physical page, computes the attributes, depending
- *    on vseg type, and updates directly (without RPC) the local GPT and the reference GPT.
- *    Other GPT copies  will updated on demand.
- * Concurrent accesses to the GPT(s) are handled, by locking the target PTE before accessing
- * the local and/or reference GPT(s).
- *********************************************************************************************
- * @ process  : local pointer on local process.
- * @ vpn      : VPN of the missing PTE.
- * @ returns EXCP_NON_FATAL / EXCP_USER_ERROR / EXCP_KERNEL_PANIC after analysis
- ********************************************************************************************/
-error_t vmm_handle_page_fault( struct process_s * process,
-                               vpn_t              vpn );
-
-/*********************************************************************************************
- * This function is called by the generic exception handler in case of WRITE violation event, 
- * detected for a given <vpn>. The <process> argument is used to access the relevant VMM.
- * It returns a kernel panic if the faulty VPN is not in a registered vseg, or is not mapped.
- * For a legal mapped vseg there is two cases:
- * 1) If the missing VPN belongs to a private vseg (STACK), it access only the local GPT.
- *    It access the forks counter in the current physical page descriptor.
- *    If there is a pending fork, it allocates a new physical page from the cluster defined 
- *    by the vseg type, copies the old physical page content to the new physical page,
- *    and decrements the pending_fork counter in old physical page descriptor.
- *    Finally, it reset the COW flag and set the WRITE flag in local GPT.
- * 2) If the missing VPN is public, it access only the reference GPT.
- *    It access the forks counter in the current physical page descriptor.
- *    If there is a pending fork, it allocates a new physical page from the cluster defined 
- *    by the vseg type, copies the old physical page content to the new physical page,
- *    and decrements the pending_fork counter in old physical page descriptor.
- *    Finally it calls the vmm_global_update_pte() function to reset the COW flag and set
- *    the WRITE flag in all the GPT copies, using a RPC if the reference cluster is remote.
- * In both cases, concurrent accesses to the GPT are handled by locking the target PTE
- * before accessing the GPT.
- *********************************************************************************************
- * @ process   : pointer on local process descriptor copy.
- * @ vpn       : VPN of the faulting PTE.
- * @ returns EXCP_NON_FATAL / EXCP_USER_ERROR / EXCP_KERNEL_PANIC after analysis
- ********************************************************************************************/
-error_t vmm_handle_cow( struct process_s * process,
-                        vpn_t              vpn );
-
-/*********************************************************************************************
- * This function is called by the vmm_get_pte() function when a page is unmapped.
- * Depending on the vseg type, defined by the <vseg> argument, it returns the PPN 
- * (Physical Page Number) associated to a missing page defined by the <vpn> argument.
- * - For the FILE type, it returns directly the physical page from the file mapper.
- * - For the CODE and DATA types, it allocates a new physical page from the cluster defined
- *   by the <vseg->cxy> field, or by the <vpn> MSB bits for a distributed vseg,
- *   and initialize this page from the .elf file mapper.
- * - For all other types, it allocates a new physical page from the cluster defined
- *   by the <vseg->cxy> field, or by the <vpn> MSB bits for a distributed vseg,
- *   but the new page is not initialized.
- *********************************************************************************************
- * @ vseg   : local pointer on vseg containing the mising page.
- * @ vpn    : Virtual Page Number identifying the missing page.
- * @ ppn    : [out] returned Physical Page Number.
- * return 0 if success / return EINVAL or ENOMEM if error.
- ********************************************************************************************/
-error_t vmm_get_one_ppn( vseg_t * vseg,
-                         vpn_t    vpn,
-                         ppn_t  * ppn );
+ * @ vpn       : [in] VPN defining the missing PTE.
+ * @ attr      : [out] PTE attributes.
+ * @ ppn       : [out] PTE ppn.
+ * @ returns 0 if success / returns ENOMEM if error.
+ ********************************************************************************************/
+error_t vmm_get_pte( struct process_s * process,
+                     vpn_t              vpn,
+                     uint32_t         * attr,
+                     ppn_t            * ppn );
+
+/*********************************************************************************************
+ * This function makes the virtual to physical address translation, using the calling 
+ * process page table. It uses identity mapping if required by the ident flag. 
+ * This address translation is required to configure the devices
+ * that have a DMA capability, or to implement the software L2/L3 cache cohérence, 
+ * using the MMC device synchronisation primitives.
+ * WARNING : the <ident> value must be defined by the CONFIG_KERNEL_IDENT parameter.
+ *********************************************************************************************
+ * @ ident     : [in] uses identity mapping if true.
+ * @ ptr       : [in] virtual address.
+ * @ paddr     : [out] pointer on buffer for physical address.
+ * @ returns 0 if success / returns ENOMEM if error.
+ ********************************************************************************************/
+error_t vmm_v2p_translate( bool_t    ident,
+                           void    * ptr,
+                           paddr_t * paddr );
+
+
+/*********************************************************************************************
+ * Pas a sa place ici [AG]
+ ********************************************************************************************/
+int sys_mmap( mmap_attr_t * mattr );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+int sys_madvise( void    * start,
+                 uint32_t  length,
+                 uint32_t  advice );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+int sys_sbrk( uint32_t current_heap_ptr, 
+              uint32_t size );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+error_t vmm_sbrk( vmm_t   * vmm, 
+                  uint32_t  current,
+                  uint32_t  size );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+error_t vmm_madvise_migrate( vmm_t    * vmm,
+                             uint32_t   start, 
+                             uint32_t   len );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+error_t vmm_madvise_willneed( vmm_t   * vmm,
+                              uint32_t  start,
+                              uint32_t  len );
+
+/*********************************************************************************************
+ ********************************************************************************************/
+error_t vmm_set_auto_migrate( vmm_t    * vmm,
+                              uint32_t   start,
+                              uint32_t   flags );
+
+/*********************************************************************************************
+ * Hypothesis: the region is shared-anon, mapper list is rdlocked, page is locked 
+ ********************************************************************************************/
+error_t vmm_broadcast_inval( vseg_t * region,
+                             page_t      * page,
+                             page_t     ** new );
+
+/*********************************************************************************************
+ * Hypothesis: the region is shared-anon, mapper list is rdlocked, page is locked 
+ ********************************************************************************************/
+error_t vmm_migrate_shared_page_seq( vseg_t * region,
+                                     page_t      * page,
+                                     page_t     ** new );
 
 #endif /* _VMM_H_ */
